/* 
   Copyright 2018-2024 LEADS-EXTRACTOR.com
   End-user license agreement (EULA 2018-2021)
 */
var STRIPE_URL = 'https://api.stripe.com/v1';
var STRIPE_KEY='rk_live_CQBbe0eXWqh859z5h1kMEkRT';
var _STATUS = "";
const PLANS = ["price_1OgOdWI8iPPibsQPbfwyYfuL","plan_Ecp1xdENQliyvF","price_1ISdW7I8iPPibsQP2feldVh1","price_1KRbtuI8iPPibsQPFue3nAmG","price_1HBk8PI8iPPibsQPC9HJetj3","price_1H31biI8iPPibsQPrqi1JWSH","price_1IFiAQI8iPPibsQPWZGoAH5L","price_1IMDWZI8iPPibsQP86U9NMmU","price_1KWxvoI8iPPibsQPGILI0fHh",
"price_1KWxwhI8iPPibsQPLPUvrSjk", "price_1KWxxaI8iPPibsQPh6QR0emS", "price_1KX4ANI8iPPibsQPU8B4NHwD"];

var customer_data = null;
var invoices_data = null;
var user = null;

function init() {
  getCustomerLicense();
}

function getCustomerLicense() {
  xhrWithAuth('GET', true, onCustomerFetched);
}

async function onCustomerFetched(error, status, response) {
  try {
    customer_data = JSON.parse(response).data[0];
  }
  catch(err)
  {
    await chrome.storage.local.remove(['LastLicenseCall', 'LastLicenseCallData']);
    document.getElementById("licenseStatus").innerHTML = "Error: Disable Incognito Mode and have the required permissions (site access) enabled";
  }

  if (status === 200)
  {
    await chrome.storage.local.remove(['LastLicenseCall', 'LastLicenseCallData']);

    if (customer_data)
    {
      invoices_data = customer_data['subscriptions']['data'][0];
      getLicense();
    }
    else
    {
      isFree();
    }

  }
  else
  {
    document.getElementById("licenseStatus").innerHTML = "Error: Disable Incognito Mode and have the required permissions (site access) enabled";
    await chrome.storage.local.remove(['LastLicenseCall', 'LastLicenseCallData']);
  }
}

function findCorrectPlanInSubscriptions(data) {
  var sub = null;
  for(var i=0; i<data.length; i++) {
    if (PLANS.includes(data[i].plan.id)) {
      sub = data[i];
    }
  }

  return sub;
}

function getLicense() {

  if (!customer_data || !invoices_data) {
    isFree();
    return;
  }

  const active_sub = findCorrectPlanInSubscriptions(customer_data['subscriptions']['data']);

  if (!active_sub) {
    FailedSoFree("TRIAL - License expired (limited data) >>");
    return;
  }

  const active_sub_plan = active_sub['plan'];

  var licenseStatus;
  var licenseStatusText;
  var licenseaccessLevel;
  if (active_sub['status'] == 'active' && active_sub_plan['active'] && active_sub_plan['usage_type'] == "licensed")
  {

      if(invoices_data['paid'] === false && invoices_data['amount_remaining'] !== 0)
      {
        FailedSoFree("TRIAL - Last invoice not yet paid. ");
        document.getElementById('GetLicense').classList.add("hidden");
        document.getElementById('unlimited-link').classList.add("hidden");
        document.getElementById('unlimited-link').classList.add("hidden");
        document.getElementById('stripe-invoice-pay-link').classList.remove("hidden");
        document.getElementById('stripe-invoice-pay-link').addEventListener("click", openStripesUnpaidVoiceTab);
      }
      else
      {
        document.getElementById('signin').classList.add("hidden");
        licenseStatusText = "PAID - Unlimited Access";
        licenseStatus = "success";
        _STATUS = "FULL";
        chrome.storage.local.set({'LastLicenseCallData': 'Paid'});
        chrome.storage.local.set({'LastLicenseCall': new Date().toDateString()});
        document.getElementById("licenseStatus").innerHTML = licenseStatusText;
      }

  }
  else {
    document.getElementById('signin').classList.add("hidden");
    FailedSoFree("TRIAL - License expired (limited data) >>");
  }

}


function openStripesUnpaidVoiceTab()
{
  chrome.tabs.create({'url': invoices_data['hosted_invoice_url']});
}

function isFree()
{
  licenseStatusText = "TRIAL (limited data) >>";
  licenseStatus = "info";
  _STATUS = "FREE";
  chrome.storage.local.set({'LastLicenseCall': new Date().toDateString()});
  document.getElementById('GetLicense').classList.remove("hidden");
  document.getElementById('unlimited-link').classList.remove("hidden");
  document.getElementById("licenseStatus").innerHTML = licenseStatusText;
  document.getElementById("licenseStatus").setAttribute("class", "red-text");
  document.getElementById('signin').classList.add("hidden");
}

function FailedSoFree(text)
{
  licenseStatusText = text;
  licenseStatus = "info";
  _STATUS = "FREE";
  chrome.storage.local.set({'LastLicenseCall': new Date().toDateString()});
  document.getElementById('GetLicense').classList.remove("hidden");
  document.getElementById('unlimited-link').classList.remove("hidden");
  document.getElementById("licenseStatus").innerHTML = licenseStatusText;
  document.getElementById("licenseStatus").setAttribute("class", "red-text");
  document.getElementById('signin').classList.add("hidden");
}

function xhrWithAuth(method, interactive, callback) {
  var retry = true;
  getUserId();

  async function getUserId() {
    await chrome.identity.getProfileUserInfo(function(userInfo) {
      user = userInfo;
      chrome.storage.local.set({'LastUserCallData': JSON.stringify(userInfo)});
      if (userInfo.email !== "" || userInfo.id !== "")
      {
        requestStartGetStripeCustomer(userInfo.email.toLowerCase());
      }

    });
  }

  function requestStartGetStripeCustomer(email) {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", STRIPE_URL + "/customers?limit=3&email=" + email);
    xhr.setRequestHeader('Authorization', 'Bearer ' + STRIPE_KEY);
    xhr.onload = requestCompleteGetStripeCustomer;
    xhr.send();
  }

  function requestCompleteGetStripeCustomer() {
      callback(null, this.status, this.response);
  }

}

function treatAsUTC(date) {
    var result = new Date(date);
    result.setMinutes(result.getMinutes() - result.getTimezoneOffset());
    return result;
}

function daysBetween(startDate, endDate) {
    var millisecondsPerDay = 24 * 60 * 60 * 1000;
    return (treatAsUTC(endDate) - treatAsUTC(startDate)) / millisecondsPerDay;
}

init();
